# route_guide

The example application for grpc

## Build

```
rebar3 compile
```

## Usage

1. Start the rebar3 shell

    ```
    rebar3 shell
    ```

2. Start the `route_guide` services in the rebar3 shell

    ```erl
    1> route_guide:start_services().
    Start service route_guide on 10000 successfully!
    ```

3. Start the client channel

    ```erl
    2> route_guide:start_client_channel().
    Start client channel channel1 for http://127.0.0.1:10000 successfully!
    ```

4. Call the `get_feature` method of route_guide services

    ```erl
    3> routeguide_route_guide_client:get_feature(#{latitude => 1, longitude => 1}, #{channel => channel1}).
    {ok,#{name => <<>>},
        [{<<"grpc-message">>,<<>>},{<<"grpc-status">>,<<"0">>}]}
    ```

## Project Structure

```
├── priv
│   └── route_guide.proto       %% The grpc services defined file
└── src
    ├── route_guide.app.src
    ├── route_guide.erl         %% mainly example codes
    ├── route_guide_pb.erl      %% generated by gpb
    ├── route_guide_svr.erl     %% the route_guide service implementation
    ├── routeguide_route_guide_bhvr.erl   %% generated by grpc-plugin
    └── routeguide_route_guide_client.erl %% generated by grpc-plugin
```
